# -*- coding: utf-8 -*-
"""
Created on Thu Sep 27 20:30:45 2018

@author: YUBA
"""
import numpy as np
import MyPack.Filters as flt

class cCandle:
        o=1
        h=2
        l=3
        c=4

# информация о сделке
class cDealInfo():

    dealtype=0
    iopen=0
    popen=0
    iclose=0
    pclose=0
    imm=0
    mmprice=0
    prof=0
    maxprof=0

    def __init__ (self):
        self.Reset()

    def Reset(self):
        self.dealtype=0
        self.iopen=0
        self.popen=0
        self.iclose=0
        self.pclose=0
        self.imm=0
        self.mmprice=0
        self.prof=0
        self.maxprof=0
        
    def Output(self):
        return [self.dealtype,self.iopen,self.popen,
        self.iclose,self.pclose,self.imm,self.mmprice,
        self.prof,self.maxprof]
    
    def Title(self):
        t=['Dtype','Iopen','Popen','Iclose','Pclose','Imm','Pmm','Prof','MaxProf']
        return t


# Трейлинг стоп
TrStop = 20
# StopLoss
LsStop=20

class Strategy():

    # индикаторы
    f21=[]
    f22=[]
    #статус сделки
    ds=0
    # отчет по сделке
    dr=[0,0,0,0,0,0,0]

    def __init__ (self, history=""):
        if len(history)>0:
            self.history=np.array(history)
            self.LoadDate()
            self.DealInf=cDealInfo()

    #загрузка и вычисление индикаторов.
    def LoadDate(self):
        self.f21=flt.Ema(self.history,15.0)
        self.f22=flt.Ema(self.history,30.0)

    # старт тест
    def StartStrategy(self):
        #I=np.arange(0,len(self.history),1)
        I=len((self.history))
        i=0
        while i<I:
            dt=self._Condition(i)
            if dt !=0:
                i=self._Deal(i,dt)
            i=i+1
        print("StartStrategy")
        return I

    #условия входа в сделку
    def Condition(self,i):
        if i<2:
            return 0
        df21=self.f21[i]-self.f21[i-1]
        df22=self.f22[i]-self.f22[i-1]
        d2f21=self.f21[i]-2.0*self.f21[i-1]+self.f21[i-2]
        d2f22=self.f22[i]-2.0*self.f22[i-1]+self.f22[i-2]
        dt=0
        # условия входа в сделку
        Cl=df21>0 and self.f21[i]>self.f22[i]
        Cs=df21<0 and self.f21[i]<self.f22[i]
        if Cl and self.history[i]>self.f21[i] and self.history[i]>self.f22[i]:
            dt=1
        elif Cs and self.history[i]<self.f21[i] and self.history[i]<self.f22[i]:
            dt=-1
        else:
            dt=0
        print("Condition")
        if dt !=0:
            self.DealInf.Reset()
        return dt

    # сопровождение сделки
    def _Deal(self,i,dt):
        print("Strategy._Deal() "+ str(i))
        if self.DealInf.dealtype ==0:
            self.DealInf.dealtype=dt
            self.DealInf.iopen=i
            self.DealInf.popen=self.history[i]
            self.DealInf.mmprice=self.history[i]
            return dt,0
        elif self.DealInf.dealtype ==1:
            if self.history[i]>=self.DealInf.mmprice:
                self.DealInf.imm=i
                self.DealInf.mmprice=self.history[i]
                self.DealInf.maxprof=self.history[i]- self.DealInf.popen
                return dt,0
            else:
                if self.DealInf.mmprice - self.history[i] >=TrStop:
                    self.DealInf.iclose=i
                    self.DealInf.pclose=self.history[i]
                    self.DealInf.prof=self.history[i]-self.DealInf.popen
                    return 0,self.DealInf.Output()
                else:
                    return dt,0
        elif self.DealInf.dealtype ==-1:
            if self.history[i]<=self.DealInf.mmprice:
                self.DealInf.imm=i
                self.DealInf.mmprice=self.history[i]
                self.DealInf.maxprof=self.DealInf.popen-self.history[i]
                return dt,0
            else:
                if self.history[i]- self.DealInf.mmprice >=TrStop:
                    self.DealInf.iclose=i
                    self.DealInf.pclose=self.history[i]
                    self.DealInf.prof=self.DealInf.popen-self.history[i]
                    return 0,self.DealInf.Output()
                else:
                    return dt,0
        print("DealBase " + str(dt) + " " + str(i))
        return 0, 0

#S=Strategy(csvr.GetColumn())
print("qu-qu Strategy")